Index: /trunk/NEMOGCM/NEMO/OPA_SRC/DOM/daymod.F90
===================================================================
--- /trunk/NEMOGCM/NEMO/OPA_SRC/DOM/daymod.F90	(revision 3603)
+++ /trunk/NEMOGCM/NEMO/OPA_SRC/DOM/daymod.F90	(revision 3604)
@@ -2,18 +2,18 @@
    !!======================================================================
    !!                       ***  MODULE  daymod  ***
-   !! Ocean        :  calendar 
+   !! Ocean        :  calendar
    !!=====================================================================
    !! History :  OPA  ! 1994-09  (M. Pontaud M. Imbard)  Original code
    !!                 ! 1997-03  (O. Marti)
-   !!                 ! 1997-05  (G. Madec) 
+   !!                 ! 1997-05  (G. Madec)
    !!                 ! 1997-08  (M. Imbard)
    !!   NEMO     1.0  ! 2003-09  (G. Madec)  F90 + nyear, nmonth, nday
    !!                 ! 2004-01  (A.M. Treguier) new calculation based on adatrj
    !!                 ! 2006-08  (G. Madec)  surface module major update
-   !!----------------------------------------------------------------------      
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   day        : calendar
-   !!  
+   !!
    !!           -------------------------------
    !!           ----------- WARNING -----------
@@ -24,13 +24,13 @@
    !!           ----------- WARNING -----------
    !!           -------------------------------
-   !!  
+   !!
    !!----------------------------------------------------------------------
    USE dom_oce         ! ocean space and time domain
    USE phycst          ! physical constants
    USE in_out_manager  ! I/O manager
-   USE iom             ! 
+   USE iom             !
    USE ioipsl, ONLY :   ymds2ju   ! for calendar
    USE prtctl          ! Print control
-   USE restart         ! 
+   USE restart         !
    USE trc_oce, ONLY : lk_offline ! offline flag
    USE timing          ! Timing
@@ -41,6 +41,7 @@
    PUBLIC   day        ! called by step.F90
    PUBLIC   day_init   ! called by istate.F90
-
-   INTEGER ::   nsecd, nsecd05, ndt, ndt05
+   PUBLIC   day_mth    ! Needed by TAM
+
+   INTEGER, PUBLIC ::   nsecd, nsecd05, ndt, ndt05 ! (PUBLIC for TAM)
 
    !!----------------------------------------------------------------------
@@ -54,6 +55,6 @@
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE day_init  ***
-      !! 
-      !! ** Purpose :   Initialization of the calendar values to their values 1 time step before nit000 
+      !!
+      !! ** Purpose :   Initialization of the calendar values to their values 1 time step before nit000
       !!                because day will be called at the beginning of step
       !!
@@ -81,5 +82,5 @@
       ndt05   = NINT(0.5 * rdttra(1))
 
-      IF( .NOT. lk_offline ) CALL day_rst( nit000, 'READ' ) 
+      IF( .NOT. lk_offline ) CALL day_rst( nit000, 'READ' )
 
       ! set the calandar from ndastp (read in restart file and namelist)
@@ -87,5 +88,5 @@
       nyear   =   ndastp / 10000
       nmonth  = ( ndastp - (nyear * 10000) ) / 100
-      nday    =   ndastp - (nyear * 10000) - ( nmonth * 100 ) 
+      nday    =   ndastp - (nyear * 10000) - ( nmonth * 100 )
 
       CALL ymds2ju( nyear, nmonth, nday, 0.0, fjulday )  ! we assume that we start run at 00:00
@@ -95,7 +96,7 @@
       nsec1jan000 = 0
       CALL day_mth
-      
+
       IF ( nday == 0 ) THEN     !   for ex if ndastp = ndate0 - 1
-         nmonth = nmonth - 1  
+         nmonth = nmonth - 1
          nday = nmonth_len(nmonth)
       ENDIF
@@ -106,12 +107,12 @@
          IF( nleapy == 1 )   CALL day_mth
       ENDIF
-      
+
       ! day since january 1st
       nday_year = nday + SUM( nmonth_len(1:nmonth - 1) )
 
-      !compute number of days between last monday and today      
+      !compute number of days between last monday and today
       CALL ymds2ju( 1900, 01, 01, 0.0, zjul )  ! compute julian day value of 01.01.1900 (our reference that was a Monday)
-      inbday = NINT(fjulday - zjul)            ! compute nb day between  01.01.1900 and current day  
-      idweek = MOD(inbday, 7)                  ! compute nb day between last monday and current day  
+      inbday = NINT(fjulday - zjul)            ! compute nb day between  01.01.1900 and current day
+      idweek = MOD(inbday, 7)                  ! compute nb day between last monday and current day
 
       ! number of seconds since the beginning of current year/month/week/day at the middle of the time-step
@@ -135,5 +136,5 @@
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE day_init  ***
-      !! 
+      !!
       !! ** Purpose :   calendar values related to the months
       !!
@@ -147,5 +148,5 @@
 
       ! length of the month of the current year (from nleapy, read in namelist)
-      IF ( nleapy < 2 ) THEN 
+      IF ( nleapy < 2 ) THEN
          nmonth_len(:) = (/ 31, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31, 31 /)
          nyear_len(:) = 365
@@ -167,5 +168,5 @@
       ! time since Jan 1st   0     1     2    ...    11    12    13
       !          ---------*--|--*--|--*--| ... |--*--|--*--|--*--|--------------------------------------
-      !                 <---> <---> <--->  ...  <---> <---> <--->        
+      !                 <---> <---> <--->  ...  <---> <---> <--->
       ! month number      0     1     2    ...    11    12    13
       !
@@ -180,6 +181,6 @@
          nmonth_end(jm) = nmonth_end(jm-1) + nsecd * nmonth_len(jm)
       END DO
-      !           
-   END SUBROUTINE 
+      !
+   END SUBROUTINE
 
 
@@ -187,5 +188,5 @@
       !!----------------------------------------------------------------------
       !!                      ***  ROUTINE day  ***
-      !! 
+      !!
       !! ** Purpose :   Compute the date with a day iteration IF necessary.
       !!
@@ -199,5 +200,5 @@
       !!              - adatrj    : date in days since the beginning of the run
       !!              - nsec_year : current time of the year (in second since 00h, jan 1st)
-      !!----------------------------------------------------------------------      
+      !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt        ! ocean time-step indices
       !
@@ -210,13 +211,13 @@
       zprec = 0.1 / rday
       !                                                 ! New time-step
-      nsec_year  = nsec_year  + ndt 
-      nsec_month = nsec_month + ndt                 
+      nsec_year  = nsec_year  + ndt
+      nsec_month = nsec_month + ndt
       nsec_week  = nsec_week  + ndt
-      nsec_day   = nsec_day   + ndt                
+      nsec_day   = nsec_day   + ndt
       adatrj  = adatrj  + rdttra(1) / rday
       fjulday = fjulday + rdttra(1) / rday
       IF( ABS(fjulday - REAL(NINT(fjulday),wp)) < zprec )   fjulday = REAL(NINT(fjulday),wp)   ! avoid truncation error
       IF( ABS(adatrj  - REAL(NINT(adatrj ),wp)) < zprec )   adatrj  = REAL(NINT(adatrj ),wp)   ! avoid truncation error
-      
+
       IF( nsec_day > nsecd ) THEN                       ! New day
          !
@@ -251,5 +252,5 @@
 
       IF( nsec_week > 7*nsecd )   nsec_week = ndt05     ! New week
-      
+
       IF(ln_ctl) THEN
          WRITE(charout,FMT="('kt =', I4,'  d/m/y =',I2,I2,I4)") kt, nday, nmonth, nyear
@@ -268,14 +269,14 @@
       !!---------------------------------------------------------------------
       !!                   ***  ROUTINE ts_rst  ***
-      !! 
+      !!
       !!  ** Purpose : Read or write calendar in restart file:
-      !! 
+      !!
       !!  WRITE(READ) mode:
-      !!       kt        : number of time step since the begining of the experiment at the 
+      !!       kt        : number of time step since the begining of the experiment at the
       !!                   end of the current(previous) run
-      !!       adatrj(0) : number of elapsed days since the begining of the experiment at the 
+      !!       adatrj(0) : number of elapsed days since the begining of the experiment at the
       !!                   end of the current(previous) run (REAL -> keep fractions of day)
       !!       ndastp    : date at the end of the current(previous) run (coded as yyyymmdd integer)
-      !! 
+      !!
       !!   According to namelist parameter nrstdt,
       !!       nrstdt = 0  no control on the date (nit000 is  arbitrary).
@@ -295,5 +296,5 @@
       REAL(wp) ::   zkt, zndastp
       !!----------------------------------------------------------------------
-      
+
       IF( TRIM(cdrw) == 'READ' ) THEN
 
@@ -312,24 +313,24 @@
                WRITE(numout,*)
             ENDIF
-            ! Control of date 
-            IF( nit000 - NINT( zkt ) /= 1 .AND. nrstdt /= 0 )                                         & 
-                 &   CALL ctl_stop( ' ===>>>> : problem with nit000 for the restart',                 & 
+            ! Control of date
+            IF( nit000 - NINT( zkt ) /= 1 .AND. nrstdt /= 0 )                                         &
+                 &   CALL ctl_stop( ' ===>>>> : problem with nit000 for the restart',                 &
                  &                  ' verify the restart file or rerun with nrstdt = 0 (namelist)' )
             ! define ndastp and adatrj
-            IF ( nrstdt == 2 ) THEN 
+            IF ( nrstdt == 2 ) THEN
                ! read the parameters correspondting to nit000 - 1 (last time step of previous run)
                CALL iom_get( numror, 'ndastp', zndastp )
                ndastp = NINT( zndastp )
                CALL iom_get( numror, 'adatrj', adatrj  )
-            ELSE 
+            ELSE
                ! parameters correspondting to nit000 - 1 (as we start the step loop with a call to day)
                ndastp = ndate0 - 1     ! ndate0 read in the namelist in dom_nam, we assume that we start run at 00:00
-               adatrj = ( REAL( nit000-1, wp ) * rdttra(1) ) / rday 
-               ! note this is wrong if time step has changed during run 
+               adatrj = ( REAL( nit000-1, wp ) * rdttra(1) ) / rday
+               ! note this is wrong if time step has changed during run
             ENDIF
          ELSE
             ! parameters correspondting to nit000 - 1 (as we start the step loop with a call to day)
             ndastp = ndate0 - 1        ! ndate0 read in the namelist in dom_nam, we assume that we start run at 00:00
-            adatrj = ( REAL( nit000-1, wp ) * rdttra(1) ) / rday 
+            adatrj = ( REAL( nit000-1, wp ) * rdttra(1) ) / rday
          ENDIF
          IF( ABS(adatrj  - REAL(NINT(adatrj),wp)) < 0.1 / rday )   adatrj = REAL(NINT(adatrj),wp)   ! avoid truncation error
@@ -347,8 +348,8 @@
             IF(lwp) WRITE(numout,*)
             IF(lwp) WRITE(numout,*) 'rst_write : write oce restart file  kt =', kt
-            IF(lwp) WRITE(numout,*) '~~~~~~~'         
+            IF(lwp) WRITE(numout,*) '~~~~~~~'
          ENDIF
          ! calendar control
-         CALL iom_rstput( kt, nitrst, numrow, 'kt'     , REAL( kt    , wp) )   ! time-step 
+         CALL iom_rstput( kt, nitrst, numrow, 'kt'     , REAL( kt    , wp) )   ! time-step
          CALL iom_rstput( kt, nitrst, numrow, 'ndastp' , REAL( ndastp, wp) )   ! date
          CALL iom_rstput( kt, nitrst, numrow, 'adatrj' , adatrj            )   ! number of elapsed days since
Index: /trunk/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- /trunk/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3603)
+++ /trunk/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3604)
@@ -128,18 +128,18 @@
    INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_znl  ! dimension ndim_rank_znl, number of the procs into the same znl domain
 
-   ! North fold condition in mpp_mpi with jpni > 1
-   INTEGER ::   ngrp_world        ! group ID for the world processors
-   INTEGER ::   ngrp_opa          ! group ID for the opa processors
-   INTEGER ::   ngrp_north        ! group ID for the northern processors (to be fold)
-   INTEGER ::   ncomm_north       ! communicator made by the processors belonging to ngrp_north
-   INTEGER ::   ndim_rank_north   ! number of 'sea' processor in the northern line (can be /= jpni !)
-   INTEGER ::   njmppmax          ! value of njmpp for the processors of the northern line
-   INTEGER ::   north_root        ! number (in the comm_opa) of proc 0 in the northern comm
-   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_north   ! dimension ndim_rank_north
+   ! North fold condition in mpp_mpi with jpni > 1 (PUBLIC for TAM)
+   INTEGER, PUBLIC ::   ngrp_world        ! group ID for the world processors
+   INTEGER, PUBLIC ::   ngrp_opa          ! group ID for the opa processors
+   INTEGER, PUBLIC ::   ngrp_north        ! group ID for the northern processors (to be fold)
+   INTEGER, PUBLIC ::   ncomm_north       ! communicator made by the processors belonging to ngrp_north
+   INTEGER, PUBLIC ::   ndim_rank_north   ! number of 'sea' processor in the northern line (can be /= jpni !)
+   INTEGER, PUBLIC ::   njmppmax          ! value of njmpp for the processors of the northern line
+   INTEGER, PUBLIC ::   north_root        ! number (in the comm_opa) of proc 0 in the northern comm
+   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE, PUBLIC ::   nrank_north   ! dimension ndim_rank_north
 
    ! Type of send : standard, buffered, immediate
-   CHARACTER(len=1) ::   cn_mpi_send = 'S'    ! type od mpi send/recieve (S=standard, B=bsend, I=isend)
-   LOGICAL          ::   l_isend = .FALSE.   ! isend use indicator (T if cn_mpi_send='I')
-   INTEGER          ::   nn_buffer = 0       ! size of the buffer in case of mpi_bsend
+   CHARACTER(len=1), PUBLIC ::   cn_mpi_send = 'S'    ! type od mpi send/recieve (S=standard, B=bsend, I=isend)
+   LOGICAL, PUBLIC          ::   l_isend = .FALSE.   ! isend use indicator (T if cn_mpi_send='I')
+   INTEGER, PUBLIC          ::   nn_buffer = 0       ! size of the buffer in case of mpi_bsend
 
    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE :: tampon  ! buffer in case of bsend
Index: /trunk/NEMOGCM/NEMO/OPA_SRC/TAM/tamtrj.F90
===================================================================
--- /trunk/NEMOGCM/NEMO/OPA_SRC/TAM/tamtrj.F90	(revision 3604)
+++ /trunk/NEMOGCM/NEMO/OPA_SRC/TAM/tamtrj.F90	(revision 3604)
@@ -0,0 +1,219 @@
+MODULE tamtrj
+   !!======================================================================
+   !!                       ***  MODULE tamtrj  ***
+   !! Tangent and adjoint  trajectory interface: Write to file
+   !!                                    the model state trajectory
+   !!======================================================================
+   !!----------------------------------------------------------------------
+   !!   tam_trj_ini  : init: read the namelist
+   !!   tam_trj_wri  : Write out the model state trajectory
+   !!----------------------------------------------------------------------
+   !! * Modules used
+   USE oce                ! Dynamics and active tracers defined in memory
+   USE sbc_oce            ! Ocean surface boundary conditions
+   USE zdf_oce            ! Vertical mixing variables
+#if defined key_zdfddm
+   USE zdfddm             ! Double diffusion mixing parameterization
+#endif
+   USE ldftra_oce         ! Lateral tracer mixing coefficient defined in memory
+#if   defined key_ldfslp
+   USE ldfslp
+#endif
+#if defined key_traldf_c2d
+   USE ldfeiv             ! eddy induced velocity coef.      (ldf_eiv routine)
+#endif
+#if defined key_zdftke
+   USE zdftke             ! TKE vertical physics
+#endif
+   USE eosbn2             ! Equation of state (eos_bn2 routine)
+   USE zdfbfr
+   USE tradmp             ! Tracer damping
+   USE sol_oce
+   USE trc_oce
+   USE in_out_manager
+   USE dom_oce
+   USE iom                 ! I/O module
+   USE zdfmxl
+
+   IMPLICIT NONE
+
+   !! * Routine accessibility
+   PRIVATE
+   PUBLIC tam_trj_init, &  !: Write out the background state
+      &   tam_trj_wri      !: Write out the background state
+
+   LOGICAL, PUBLIC :: &
+      & ln_trjhand = .FALSE.   !: No output of the state trajectory fields
+
+   LOGICAL :: &
+      & ln_trj_spl            !: save the trajectory at simple precision
+
+   CHARACTER (LEN=40), PUBLIC :: &
+      & cn_dirtrj                                  !: Filename for storing the
+                                                   !: reference trajectory
+   INTEGER, PUBLIC :: &
+      & nn_ittrjfrq         !: Frequency of trajectory output for 4D-VAR
+
+CONTAINS
+   SUBROUTINE tam_trj_init
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE tam_trj_init ***
+      !!
+      !! ** Purpose : initialize the model state trajectory
+      !!
+      !! ** Method  :
+      !!
+      !! ** Action  :
+      !!
+      !! References :
+      !!
+      !! History :
+      !!        ! 10-01 (A. Vidard)
+      !!-----------------------------------------------------------------------
+
+      IMPLICIT NONE
+
+      !! * Modules used
+      NAMELIST/namtrj/ nn_ittrjfrq, ln_trjhand, cn_dirtrj, ln_trj_spl
+
+      cn_dirtrj   = 'tam_trajectory'
+      ln_trjhand = .FALSE.
+      nn_ittrjfrq = 1
+      ln_trj_spl  = .TRUE.
+
+      REWIND ( numnam )
+      READ   ( numnam, namtrj )
+
+      ! Control print
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tam_trj_ini : Trajectory handling:'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) '          Namelist namtam : set trajectory parameters'
+         WRITE(numout,*) '             Logical switch for handling state trajectory         ', &
+            &            ' ln_trjhand = ', ln_trjhand
+         WRITE(numout,*) '             Logical switch for handling it at simple precision       ', &
+            &            ' ln_trj_spl  = ', ln_trj_spl
+         WRITE(numout,*) '             Frequency of trajectory output (or input for TAM)                          ', &
+            &            ' nn_ittrjfrq = ', nn_ittrjfrq
+      END IF
+   END SUBROUTINE tam_trj_init
+   SUBROUTINE tam_trj_wri( kt )
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE tam_trj_wri ***
+      !!
+      !! ** Purpose : Write to file the model state trajectory
+      !!
+      !! ** Method  :
+      !!
+      !! ** Action  :
+      !!
+      !! References :
+      !!
+      !! History :
+      !!        ! 2007-04 (A. Weaver)
+      !!        ! 2009-03 (F. Vigilant) Add hmlp (zdfmxl) for no tracer nmldp=2
+      !!        ! 2009-06 (F. Vigilant) special case when kt=nit000-1
+      !!        ! 2009-07 (F. Vigilant) add computation of eiv at restart
+      !!        ! 2010-01 (A. Vidard) asm_trj_wri->tam_trj_wri
+      !!        ! 2010-04 (F. Vigilant) converison to 3.2
+      !!-----------------------------------------------------------------------
+
+      !! * Arguments
+      INTEGER, INTENT( IN ) :: &
+         & kt                    ! Current time-step
+
+      !! * Local declarations
+      INTEGER :: &
+         & inum                  ! File unit number
+      INTEGER :: &
+         & it
+      INTEGER :: &
+         & ntype
+      CHARACTER (LEN=50) :: &
+         & cl_dirtrj
+      REAL(wp) :: &
+         & zdate            ! Date
+
+      IF ( ln_trj_spl ) THEN ; ntype = jp_r4
+                        ELSE ; ntype = jp_r8 ; ENDIF
+      !------------------------------------------------------------------------
+      ! Write a single file for each trajectory time step
+      !------------------------------------------------------------------------
+      !------------------------------------------------------------------------
+      ! Write a single file for each trajectory time step
+      !------------------------------------------------------------------------
+      IF( ( MOD( kt - nit000 + 1, nn_ittrjfrq ) == 0 ) .OR. ( kt == nitend ) ) THEN
+
+         IF( kt == nit000 - 1 ) THEN         ! Treat special case when kt = nit000-1
+            !
+#if defined key_zdftke
+            IF(lwp) WRITE(numout,*) ' Computing  zdf_tke coeff. form restart...'
+            ! Compute the vertical eddy viscosity and diffusivity coefficients
+            CALL zdf_tke( nit000 )
+#endif
+#if defined key_zdfddm
+            IF(lwp) WRITE(numout,*) ' Computing zdf_ddm coeff. from restart...'
+            ! Compute the vertical eddy viscosity and diffusivity coefficients (salt effect)
+            CALL zdf_ddm( nit000 )
+#endif
+            IF(lwp) WRITE(numout,*) ' Computing zdf_mxl coeff. from restart...'
+            ! Compute the turbocline depth and the mixed layer depth
+            CALL zdf_mxl( nit000 )
+#if defined key_ldfslp
+            IF(lwp) WRITE(numout,*) ' Compute the slopes of neutral surface...'
+            CALL bn2( tsb, rn2 )
+            CALL ldf_slp( nit000, rhd, rn2 )
+#endif
+#if defined key_traldf_c2d
+            IF(lwp) WRITE(numout,*) ' Computing ldf_eiv coeff. from restart...'
+            ! Compute eddy induced velocity coefficient
+            IF( lk_traldf_eiv )   CALL ldf_eiv( nit000 )
+#endif
+         ENDIF
+         !
+         it = kt - nit000 + 1
+         !
+         ! Define the output file
+         WRITE(cl_dirtrj, FMT='(I5.5,A,A)' ) it, '_', TRIM( cn_dirtrj )
+         cl_dirtrj = TRIM( cl_dirtrj )
+         CALL iom_open( cl_dirtrj, inum, ldwrt = .TRUE., kiolib = jprstlib)
+
+         ! Output trajectory fields
+         CALL iom_rstput( it, it, inum, 'emp'   , emp   , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'emps'  , emps  , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'un'    , un    , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'vn'    , vn    , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'tn'    , tsn(:,:,:,jp_tem)    , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'sn'    , tsn(:,:,:,jp_sal)    , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'avmu'  , avmu  , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'avmv'  , avmv  , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'avt'   , avt   , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'bfrua' , bfrua , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'bfrva' , bfrva , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'etot3' , etot3 , ktype = ntype )
+#if defined key_ldfslp
+         CALL iom_rstput( it, it, inum, 'uslp'  , uslp  , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'vslp'  , vslp  , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'wslpi' , wslpi , ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'wslpj' , wslpj , ktype = ntype )
+#endif
+#if defined key_zdfddm
+         CALL iom_rstput( it, it, inum, 'avs'   , avs , ktype = ntype )
+#endif
+         IF( ln_tradmp ) THEN
+            CALL iom_rstput( it, it, inum, 'hmlp'  , hmlp  , ktype = ntype )
+            CALL iom_rstput( it, it, inum, 'strdmp', strdmp, ktype = ntype )
+         END IF
+         CALL iom_rstput( it, it, inum, 'aeiu'  , aeiu, ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'aeiv'  , aeiv, ktype = ntype )
+         CALL iom_rstput( it, it, inum, 'aeiw'  , aeiw, ktype = ntype )
+
+         CALL iom_close( inum )
+
+      ENDIF
+
+   END SUBROUTINE tam_trj_wri
+END MODULE tamtrj
